library xdll_systeme;

(*
Copyright (C) 2010 Pierre Dieumegard  Tous droits rservs.
 pierre.dieumegard@ac-orleans-tours.fr 
====================================================
(fr)
  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le   modifier suivant les termes de la GNU General Public License telle que   publie par la Free Software Foundation : soit la version 3 de cette   licence, soit ( votre gr) toute version ultrieure.
  
  Ce programme est distribu dans lespoir quil vous sera utile, mais SANS AUCUNE GARANTIE : sans mme la garantie implicite de COMMERCIALISABILIT  ni dADQUATION  UN OBJECTIF PARTICULIER. Consultez la Licence Gnrale   Publique GNU pour plus de dtails.
  
  Vous devriez avoir reu une copie de la Licence Gnrale Publique GNU avec ce programme ; si ce nest pas le cas, consultez :<http://www.gnu.org/licenses/>.


Ces pilotes sont destins notamment aux logiciels de type MGW32 et Visu32 (http://sciencexp.free.fr)

This driver has analog inputs for system clock. Logical (binary) outputs are LED from the keyboard, and Open/close CD-tray
==============================================================================
(en)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

These drivers are designed for softwares as MGW32 or Visu32 (http://sciencexp.free.fr).

This driver has analog inputs for system clock. Logical (binary) outputs are LED from the keyboard, and Open/close CD-tray
=============================================================================
(eo)
Chi tiu programo estas libera: vi povas modifi au distribui
    ghin lau la kondichoj de la Generala Publika Permesilo de GNU eldonite de
    la Fondajho pri Libera Programaro au eldona 3-a de la permesilo a
    (lauvole) pli malfrua eldono.

    Chi tiu programo estas distribuita kun esperoj pri utileco,
    sed TUTE SEN GARANTIO; sen ech la implica garantio pri
    VENDEBLECO au CELKONFORMECO. Vidu al la
    Ghenerala Publika Permesilo de GNU por pli da detaloj.

    Vi probable ricevis ekzempleron de la Ghenerala Publika Permesilo de GNU
    kune kun chi tiu programo. Aliokaze vidu <http://www.gnu.org/licenses/>.
	
Tiuj peliloj uzeblas per programoj kiel MGW32 a Visu32 (http://sciencexp.free.fr).

Analogaj mezuroj per tiu pelilo estas nur tempo de la sistem-horlogho.
Duumaj agiloj estas nur lum-diodoj de la klavaro, kaj malfermo/fermo de diskpleto.
*)


uses
  sysutils,MMsystem,classes,
  wintypes;

type pdouble=^double;
     psingle=^single;
var memosb:array[0..8]of longint;
    memosa:longint;
    memosad:double;

    type
 TKeyType = (ktCapsLock, ktNumLock, ktScrollLock);

procedure SetLedState(KeyCode: TKeyType; bOn: Boolean);
var
 KBState: TKeyboardState;
 Code: Byte;
begin
 case KeyCode of
   ktScrollLock: Code := VK_SCROLL;
   ktCapsLock: Code := VK_CAPITAL;
   ktNumLock: Code := VK_NUMLOCK;
 end;
 GetKeyboardState(KBState);
 if (Win32Platform = VER_PLATFORM_WIN32_NT) then
 begin
   if Boolean(KBState[Code]) <> bOn then
   begin
     keybd_event(Code,
                 MapVirtualKey(Code, 0),
                 KEYEVENTF_EXTENDEDKEY,
                 0);

     keybd_event(Code,
                 MapVirtualKey(Code, 0),
                 KEYEVENTF_EXTENDEDKEY or KEYEVENTF_KEYUP,
                 0);
   end;
 end
 else
 begin
   KBState[Code] := Ord(bOn);
   SetKeyboardState(KBState);
 end;
end;


type
  TCDOpener = class(TComponent)
  procedure OpenCd(AOpen:Boolean);
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
  end;
procedure TCDOpener.OpenCd(AOpen: Boolean);
const
    DoPlay : array[Boolean] of string =
                ('Set cdaudio door closed wait',
         'Set cdaudio door open wait');
var
   MyError       : LongInt;
   MyErrorString : array[0..MAXERRORLENGTH - 1] of char;
begin
   MyError := mciSendString(pChar(DoPlay[AOpen]), nil, 0, 0);
   if MyError <> 0 then
   begin
     MciGetErrorString(MyError,MyErrorString,MAXERRORLENGTH - 1);
     //Showmessage(MyErrorString);
     Exit;
   end;
end;

 var cdopener:tcdopener;

function ea(n:longint):longint;
var h,min,s,msec:word;
begin (*on suppose 4 voies d''entre analogique*)
  ea:=-777;
  case n of
     0 : begin
           DecodeTime(now,h, Min, S, MSec);
           ea:=h*3600+min*60+s;
         end;
     end; //case
end;

function nea(n:longint):pchar;
begin
  case n of
    0 :nea:=pchar('secondes du jour');
    else nea:=pchar('');
    end;
end;

function ead(n:longint):double;
begin
  //if (n=0) or (n=1)or (n=2) or (n=3) then ead:=n*5.555 else ead:=n;
  ead:=-777;
  case n of
    0 : ead:=ea(0);
    1 : ead:=now;
    end; //case
end;

function nead(n:longint):pchar;
begin
case n of
  0 : nead:=pchar('secondes du jour');
  1 : nead:=pchar('date.heure');
  else nead:=pchar('');
  end;
end;

function sa(n:longint; valeur:longint):longint;
begin (*une seule sortie analogique*)
if n=0
   then begin memosa:=n ; sa:=n;
        end
   else sa:=-777;
end;

function nsa(n:longint):pchar;
begin
if n=0 then  nsa:=pchar('sortie analogique fictive') else nsa:=pchar('');
end;

function sad(n:longint ; valeur:double):double;
begin
if n=0 then begin memosad:=valeur; sad:=valeur;
            end
       else sad:=-777;
end;

function nsad(n:longint):pchar;
begin
   if n=0 then nsad:=pchar('sortie analogique fictive')else nsad:=pchar('');
end;

function rsa(n:longint):longint;
begin       (*tat de la sortie analogique fictive*)
if n=0 then rsa:=memosa else rsa:=-777;
end;

function rsad(n:longint):double;
begin
  if n=0 then rsad:=memosad else rsad:=-777;
end;

function eb(n:longint):longint;
begin  (*2 entres logiques fictives*)
 if n=0 then eb:=0 else if n=1 then eb:=1 else eb:=-777;
end;

function neb(n:longint):pchar;
begin
 if n=0 then neb:=pchar('EB fictive 0')
        else if n=1 then neb:=pchar('EB fictive 1')
                    else neb:=pchar('');
end;

function sb(n:longint; etat:longint):longint;
begin
 case n of
   0 : if etat=1 then setledstate(ktcapslock,true) else setledstate(ktcapslock,false);
   1 : if etat=1 then setledstate(ktnumlock,true) else setledstate(ktnumlock,false);
   2 : if etat=1 then setledstate(ktscrolllock,true) else setledstate(ktscrolllock,false);
   3 : if etat=1 then cdopener.opencd(true) else cdopener.opencd(false);
   else sb:=-777;
    end;
  if n in [0..7] then memosb[n]:=etat;
end;

function nsb(n:longint):pchar;
begin
result:=pchar('');
if n=0 then result:=pchar('Verr. Majusc.');
if n=1 then result:=pchar('Verr. Num.');
if n=2 then result:=pchar('Arrt Dfil');
if n=3 then result:=pchar('CD ouvert');
end;

function rsb(n:longint):longint;
begin
  if n in [0..8] then rsb:=memosb[n]
                else rsb:=-777;
end;

function titre : pchar;export;
begin titre:=pchar('Systme PC');end;

function detail : pchar;      export;
begin detail:=pchar('DLL (32 bits) pour systme PC, par P. Dieumegard, le 21 avril 2010');end;

(*les deux fonctions qui suivent sont pour EXCEL*)
function pead(n:longint):pdouble; export;
var dloc:double;
begin dloc:=ead(n);pead:=@dloc;end;

function psad(n:longint;valeur:pdouble):pdouble;export;
var dloc1,dloc2:double;
begin dloc1:=valeur^;dloc2:=sad(n,dloc1);psad:=@dloc2;end;
function pstdead(n:longint):pdouble;stdcall;export;
begin pstdead:=pead(n);end;

    (*les fonctions "std" qui suivent sont pour
    C++Builder, MSWLogo, VisualBasic, etc*)
function stdea(x:longint):longint;stdcall;export;
begin stdea:=ea(x);end;
function stdnea(x:longint):pchar;stdcall;export;
begin stdnea:=nea(x);end;
function stdnead(x:longint):pchar;stdcall; export;
begin stdnead:=nead(x);end;
function stdead(x:longint):double;stdcall;export;
begin stdead:=ead(x); end;
function stdsa(n:longint;valeur:longint):longint;stdcall;export;
begin stdsa:=sa(n,valeur);end;
function stdnsa(n:longint):pchar; stdcall;export;
begin stdnsa:=nsa(n);end;
function stdrsa(n:longint):longint; stdcall;export;
begin stdrsa:=rsa(n);end;

function stdsad(n:longint ; valeur:double):double; stdcall;export;

begin stdsad:=sad(n,valeur);end;
function stdnsad(n:longint):pchar;stdcall;export;
begin stdnsad:=nsad(n);end;
function stdrsad(n:longint):double ; stdcall;export;
begin stdrsad:=rsad(n);end;
function stdeb(n:longint):longint;stdcall;export;
begin stdeb:=eb(n);end;
function stdneb(n:longint):pchar;stdcall;export;
begin stdneb:=neb(n);end;
function stdsb(n:longint; valeur:longint):longint;stdcall;export;
begin stdsb:=sb(n,valeur);end;
function stdnsb(n:longint):pchar;stdcall;export;
begin stdnsb:=nsb(n);end;
function stdrsb(n:longint):longint;stdcall;export;
begin stdrsb:=rsb(n);end;
function stdtitre:pchar;stdcall;export;
begin stdtitre:=titre;end;
function stddetail:pchar;stdcall;export;
begin stddetail:=detail;end;

function stdeas(n:longint):single;stdcall;export;
begin stdeas:=77.77;end;
function stdsas(n:longint;val:single):single;stdcall;export;
begin stdsas:=stdsad(n,val);end;
function stdrsas(n:longint):single;stdcall;export;
begin stdrsas:=stdrsad(n);end;

function pstdeas(n:longint):psingle;stdcall;
var varloc:single;
begin varloc:=stdead(n);pstdeas:=@varloc;end;
    (*les fonctions " double " qui suivent sont pour StarOffice*)
function eadouble(x:double):double;    export;
begin  eadouble:=ead(round(x));  end;

function neadouble(x:double):pchar;
begin    neadouble:=nead(round(x));end;

function sadouble(x:double;xval:double):double;
begin sadouble:=sad(round(x),xval);end;

function nsadouble(x:double):pchar;
begin nsadouble:=nsad(round(x));end;

function rsadouble(x:double):double;
begin rsadouble:=rsad(round(x));end;

function ebdouble(x:double):double;
begin ebdouble:=eb(round(x));end;

function nebdouble(x:double):pchar;
begin nebdouble:=neb(round(x));end;

function sbdouble(n:double;etat:double):double;
begin sbdouble:=sb(round(n),round(etat));end;

function nsbdouble(n:double):pchar;
begin nsbdouble:=nsb(round(n));end;

function rsbdouble(n:double):double;
begin rsbdouble:=rsb(round(n));end;

function stdeadouble(x:double):double;stdcall;export;
begin  stdeadouble:=ead(round(x));  end;

function stdneadouble(x:double):pchar;stdcall;export;
begin    stdneadouble:=nead(round(x));end;

function stdsadouble(x:double;xval:double):double;stdcall;export;
begin stdsadouble:=sad(round(x),xval);end;

function stdnsadouble(x:double):pchar;stdcall;export;
begin stdnsadouble:=nsad(round(x));end;

function stdrsadouble(x:double):double;stdcall;export;
begin stdrsadouble:=rsad(round(x));end;

function stdebdouble(x:double):double;stdcall;export;
begin stdebdouble:=eb(round(x));end;

function stdnebdouble(x:double):pchar;stdcall;export;
begin stdnebdouble:=neb(round(x));end;

function stdsbdouble(n:double;etat:double):double;stdcall;export;
begin stdsbdouble:=sb(round(n),round(etat));end;

function stdnsbdouble(n:double):pchar;stdcall;export;
begin stdnsbdouble:=nsb(round(n));end;

function stdrsbdouble(n:double):double;stdcall;export;
begin stdrsbdouble:=rsb(round(n));end;

function titreparamdouble(n:double):pchar;stdcall;export;
begin titreparamdouble:=titre;end;

function detailparamdouble(n:double):pchar;stdcall;export;
begin detailparamdouble:=detail;end;
function titreparam(n:longint):pchar;stdcall;export;
begin titreparam:=titre;end;

function detailparam(n:longint):pchar;stdcall;export;
begin detailparam:=detail;end;

function cea(x:longint):longint;cdecl;export;
begin cea:=ea(x);end;
function cnea(x:longint):pchar;cdecl;export;
begin cnea:=nea(x);end;
function cnead(x:longint):pchar;cdecl; export;
begin cnead:=nead(x);end;
function cead(x:longint):double;cdecl;export;
begin cead:=ead(x); end;
function csa(n:longint;valeur:longint):longint;cdecl;export;
begin csa:=sa(n,valeur);end;
function cnsa(n:longint):pchar; cdecl;export;
begin cnsa:=nsa(n);end;
function crsa(n:longint):longint; cdecl;export;
begin crsa:=rsa(n);end;

function csad(n:longint ; valeur:double):double; cdecl;export;
begin csad:=sad(n,valeur);end;
function cnsad(n:longint):pchar;cdecl;export;
begin cnsad:=nsad(n);end;
function crsad(n:longint):double ; cdecl;export;
begin crsad:=rsad(n);end;
function ceb(n:longint):longint;cdecl;export;
begin ceb:=eb(n);end;
function cneb(n:longint):pchar;cdecl;export;
begin cneb:=neb(n);end;
function csb(n:longint; valeur:longint):longint;cdecl;export;
begin csb:=sb(n,valeur);end;
function cnsb(n:longint):pchar;cdecl;export;
begin cnsb:=nsb(n);end;
function crsb(n:longint):longint;cdecl;export;
begin crsb:=rsb(n);end;
function ctitre:pchar;cdecl;export;
begin ctitre:=titre;end;
function cdetail:pchar;cdecl;export;
begin cdetail:=detail;end;

function ceas(n:longint):single;cdecl;export;
begin ceas:=77.77;end;
function csas(n:longint;val:single):single;cdecl;export;
begin csas:=csad(n,val);end;
function crsas(n:longint):single;cdecl;export;
begin crsas:=crsad(n);end;

function pceas(n:longint):psingle;cdecl;
var varloc:single;
begin varloc:=cead(n);pceas:=@varloc;end;
function ceadouble(x:double):double;cdecl;export;
begin  ceadouble:=ead(round(x));  end;

function cneadouble(x:double):pchar;cdecl;export;
begin    cneadouble:=nead(round(x));end;

function csadouble(x:double;xval:double):double;cdecl;export;
begin csadouble:=sad(round(x),xval);end;

function cnsadouble(x:double):pchar;cdecl;export;
begin cnsadouble:=nsad(round(x));end;

function crsadouble(x:double):double;cdecl;export;
begin crsadouble:=rsad(round(x));end;

function cebdouble(x:double):double;cdecl;export;
begin cebdouble:=eb(round(x));end;

function cnebdouble(x:double):pchar;cdecl;export;
begin cnebdouble:=neb(round(x));end;

function csbdouble(n:double;etat:double):double;cdecl;export;
begin csbdouble:=sb(round(n),round(etat));end;

function cnsbdouble(n:double):pchar;cdecl;export;
begin cnsbdouble:=nsb(round(n));end;

function crsbdouble(n:double):double;cdecl;export;
begin crsbdouble:=rsb(round(n));end;

exports
  ea ,  nea ,  ead ,  nead,   sa ,  nsa,  sad ,  nsad ,  rsa ,  rsad ,
  eb ,neb ,sb ,nsb ,rsb ,titre ,detail,pead ,    psad ,  pstdead, pstdeas,
  eadouble ,  neadouble ,sadouble,nsadouble,rsadouble,
  ebdouble,nebdouble, sbdouble, nsbdouble,rsbdouble,
  stdea, stdnea,stdead,stdnead, stdsa,stdnsa,
  stdsad,stdnsad,stdeb,stdneb,stdsb,stdnsb,stdrsad,stdrsb,
  stdtitre,stddetail, stdeas,stdsas,stdrsas,
    stdeadouble,stdneadouble,stdsadouble,stdnsadouble,stdrsadouble,
  stdebdouble,stdnebdouble,stdsbdouble,stdnsbdouble,stdrsbdouble,

  cea, cnea,cead,cnead,csa,cnsa,crsa,csad,cnsad,crsad,ceb,cneb,csb,cnsb,crsb,
  ctitre,cdetail, ceas,csas,crsas,pceas,
  ceadouble,cneadouble,csadouble,cnsadouble,crsadouble,
  cebdouble,cnebdouble,csbdouble,cnsbdouble,crsbdouble,

  titreparam,detailparam,titreparamdouble,detailparamdouble;

begin
//initialisation ventuelle de l'appareil
end.

